/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.59 Revision 1.94
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.59 2007/01/05 00:07:23 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.94 2008/05/29 05:33:49 robbat2 Exp $
4# kate: encoding utf-8; eol unix;
5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off;
6# kate: word-wrap-column 80; word-wrap off;
7 4
8# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 5# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: MySQL Team <mysql-bugs@gentoo.org>
9# Maintainer: Luca Longinotti <chtekk@gentoo.org> 7# - Luca Longinotti <chtekk@gentoo.org>
8# - Robin H. Johnson <robbat2@gentoo.org>
10 9
11# Note that MYSQL_VERSION_ID must be empty !!!
12
13ECLASS="mysql"
14INHERITED="$INHERITED $ECLASS"
15WANT_AUTOCONF="latest" 10WANT_AUTOCONF="latest"
16WANT_AUTOMAKE="latest" 11WANT_AUTOMAKE="latest"
12
17inherit eutils flag-o-matic gnuconfig autotools mysql_fx 13inherit eutils flag-o-matic gnuconfig autotools mysql_fx
18 14
19# Shorten the path because the socket path length must be shorter than 107 chars 15# Shorten the path because the socket path length must be shorter than 107 chars
20# and we will run a mysql server during test phase 16# and we will run a mysql server during test phase
21S="${WORKDIR}/mysql" 17S="${WORKDIR}/mysql"
22 18
23# avoid running userspace code 8 times per ebuild :(
24if [[ "${_MYPVR}" != "${PVR}" ]] && [[ -n "${PVR}" ]]
25then
26 _MYPVR=${PVR}
27
28 [[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070105" 19[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070108"
20if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
21 EGIT_PROJECT=mysql-extras
22 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
23 inherit git
24fi
29 25
30 if [[ ${PR#r} -lt 60 ]] ; then 26if [[ ${PR#r} -lt 60 ]] ; then
31 IS_BITKEEPER=0 27 IS_BITKEEPER=0
32 elif [[ ${PR#r} -lt 90 ]] ; then 28elif [[ ${PR#r} -lt 90 ]] ; then
33 IS_BITKEEPER=60 29 IS_BITKEEPER=60
34 else 30else
35 IS_BITKEEPER=90 31 IS_BITKEEPER=90
36 fi 32fi
37 33
38 # MYSQL_VERSION_ID will be: 34# MYSQL_VERSION_ID will be:
39 # major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 35# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
40 # This is an important part, because many of the choices the MySQL ebuild will do 36# This is an important part, because many of the choices the MySQL ebuild will do
41 # depend on this variable. 37# depend on this variable.
42 # In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 38# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
39# We also strip off upstream's trailing letter that they use to respin tarballs
40
43 MYSQL_VERSION_ID="" 41MYSQL_VERSION_ID=""
42tpv="${PV%[a-z]}"
44 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 43tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
45 for vatom in 0 1 2 3 ; do 44for vatom in 0 1 2 3 ; do
46 # pad to length 2 45 # pad to length 2
47 tpv[${vatom}]="00${tpv[${vatom}]}" 46 tpv[${vatom}]="00${tpv[${vatom}]}"
48 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 47 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
49 done 48done
50 # strip leading "0" (otherwise it's considered an octal number by BASH) 49# strip leading "0" (otherwise it's considered an octal number by BASH)
51 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 50MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
52 51
53 # Be warned, *DEPEND are version-dependant 52# Be warned, *DEPEND are version-dependant
53# These are used for both runtime and compiletime
54 DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d ) 54DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
55 userland_GNU? ( sys-process/procps ) 55 userland_GNU? ( sys-process/procps )
56 >=sys-apps/sed-4 56 >=sys-apps/sed-4
57 >=sys-apps/texinfo-4.7-r1 57 >=sys-apps/texinfo-4.7-r1
58 >=sys-libs/readline-4.1 58 >=sys-libs/readline-4.1
59 >=sys-libs/zlib-1.2.3 59 >=sys-libs/zlib-1.2.3"
60 "
61 60
62 # having different flavours at the same time is not a good idea 61# Having different flavours at the same time is not a good idea
63 for i in "" "-community" "-slotted" ; do 62for i in "" "-community" ; do
64 [[ "${i}" == ${PN#mysql} ]] || 63 [[ "${i}" == ${PN#mysql} ]] ||
65 DEPEND="${DEPEND} !dev-db/mysql${i}" 64 DEPEND="${DEPEND} !dev-db/mysql${i}"
66 done 65done
67 66
67RDEPEND="${DEPEND}
68 !minimal? ( dev-db/mysql-init-scripts )
69 selinux? ( sec-policy/selinux-mysql )"
70
71# compile-time-only
68 mysql_version_is_at_least "5.1" \ 72mysql_version_is_at_least "5.1" \
69 || DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 73|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
70 74
71 # dev-perl/DBD-mysql is needed by some scripts installed by MySQL 75# compile-time-only
72 PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
73
74 if mysql_version_is_at_least "5.1.12" ; then 76mysql_version_is_at_least "5.1.12" \
75 DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )" 77&& DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )"
76 fi
77 78
78 # BitKeeper dependency, compile-time only 79# BitKeeper dependency, compile-time only
79 [[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client" 80[[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
80 81
82
83# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
84PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
85
86# Work out the default SERVER_URI correctly
87if [ -z "${SERVER_URI}" ]; then
88 # The community build is on the mirrors
89 if [ "${PN}" == "mysql-community" ]; then
90 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz"
91 # The enterprise source is on the primary site only
81 if [[ ${PN} == "mysql-slotted" ]] ; then 92 elif [ "${PN}" == "mysql" ]; then
82 DEPEND="${DEPEND} app-admin/eselect-mysql" 93 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz"
94 fi
83 fi 95fi
84 96
85 if [[ ${PN} == "mysql-slotted" ]] ; then
86 SLOT=""
87 tpv=( ${PV//[-._]/ } )
88 for vatom in 0 1 2 ; do
89 SLOT="${SLOT}${tpv[${vatom}]}_"
90 done
91 #finally SLOT=5_0_24
92 SLOT=${SLOT:0:${#SLOT}-1}
93 else
94 SLOT="0"
95 fi
96
97 # Define correct SRC_URIs 97# Define correct SRC_URIs
98 SRC_URI=" 98SRC_URI="${SERVER_URI}"
99 ${SERVER_URI} 99
100[[ ${MY_EXTRAS_VER} != live ]] && SRC_URI="${SRC_URI}
101 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
100 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 102 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
101 "
102 mysql_version_is_at_least "5.1.12" \ 103mysql_version_is_at_least "5.1.12" \
103 && [[ -n "${PBXT_VERSION}" ]] \ 104&& [[ -n "${PBXT_VERSION}" ]] \
104 && SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )" 105&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
105 106
106 DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 107DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
107 HOMEPAGE="http://www.mysql.com/" 108HOMEPAGE="http://www.mysql.com/"
108 LICENSE="GPL-2" 109LICENSE="GPL-2"
110SLOT="0"
109 IUSE="big-tables debug embedded minimal perl selinux ssl static" 111IUSE="big-tables debug embedded minimal perl selinux ssl static"
110 RESTRICT="confcache"
111 112
112 mysql_version_is_at_least "4.1" \ 113mysql_version_is_at_least "4.1" \
113 && IUSE="${IUSE} latin1" 114&& IUSE="${IUSE} latin1"
114 115
115 mysql_version_is_at_least "4.1.3" \ 116mysql_version_is_at_least "4.1.3" \
116 && IUSE="${IUSE} cluster extraengine" 117&& IUSE="${IUSE} cluster extraengine"
117 118
118 mysql_version_is_at_least "5.0" \ 119mysql_version_is_at_least "5.0" \
119 || IUSE="${IUSE} raid" 120|| IUSE="${IUSE} raid"
120 121
121 mysql_version_is_at_least "5.0.18" \ 122mysql_version_is_at_least "5.0.18" \
122 && IUSE="${IUSE} max-idx-128" 123&& IUSE="${IUSE} max-idx-128"
123 124
124 mysql_version_is_at_least "5.1" \ 125mysql_version_is_at_least "5.1" \
125 && IUSE="${IUSE} innodb" 126&& IUSE="${IUSE} innodb"
126 127
127 mysql_version_is_at_least "5.1" \ 128mysql_version_is_at_least "5.1" \
128 || IUSE="${IUSE} berkdb" 129|| IUSE="${IUSE} berkdb"
129 130
130 mysql_version_is_at_least "5.1.12" \ 131mysql_version_is_at_least "5.1.12" \
131 && IUSE="${IUSE} pbxt" 132&& IUSE="${IUSE} pbxt"
132
133 RDEPEND="${DEPEND}
134 sys-apps/mysql
135 selinux? ( sec-policy/selinux-mysql )
136 "
137
138fi # if [[ "${_MYPVR}" != "${PVR}" ]]
139 133
140EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 134EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
141 pkg_postinst pkg_config pkg_postrm 135 pkg_postinst pkg_config pkg_postrm
142 136
143# 137#
144# HELPER FUNCTIONS: 138# HELPER FUNCTIONS:
145# 139#
146 140
147bitkeeper_fetch() { 141bitkeeper_fetch() {
148
149 local reposuf 142 local reposuf
150 if [[ -z "${1}" ]] ; then 143 if [[ -z "${1}" ]] ; then
151 local tpv 144 local tpv
152 tpv=( ${PV//[-._]/ } ) 145 tpv=( ${PV//[-._]/ } )
153 reposuf="mysql-${tpv[0]}.${tpv[1]}" 146 reposuf="mysql-${tpv[0]}.${tpv[1]}"
154 else 147 else
155 reposuf="${1}" 148 reposuf="${1}"
156 fi 149 fi
157 einfo "using \"${reposuf}\" repository." 150 einfo "Using '${reposuf}' repository."
158 local repo_uri="bk://mysql.bkbits.net/${reposuf}" 151 local repo_uri="bk://mysql.bkbits.net/${reposuf}"
159 ## -- ebk_store_dir: bitkeeper sources store directory 152 ## -- ebk_store_dir: bitkeeper sources store directory
160 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src" 153 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
161 ## -- ebk_fetch_cmd: bitkeeper fetch command 154 ## -- ebk_fetch_cmd: bitkeeper fetch command
162 # always fetch the latest revision, use -r<revision> if a specified revision is wanted 155 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
163 # hint: does not work 156 # hint: does not work
164 local ebk_fetch_cmd="sfioball" 157 local ebk_fetch_cmd="sfioball"
165 ## -- ebk_update_cmd: bitkeeper update command 158 ## -- ebk_update_cmd: bitkeeper update command
166 local ebk_update_cmd="update" 159 local ebk_update_cmd="update"
167 160
168 #addread "/etc/bitkeeper" 161 # addread "/etc/bitkeeper"
169 addwrite "${ebk_store_dir}" 162 addwrite "${ebk_store_dir}"
170 163
171 if [[ ! -d "${ebk_store_dir}" ]]; then 164 if [[ ! -d "${ebk_store_dir}" ]] ; then
172 debug-print "${FUNCNAME}: initial checkout. creating bitkeeper directory" 165 debug-print "${FUNCNAME}: initial checkout, creating bitkeeper directory ..."
173 mkdir -p "${ebk_store_dir}" || die "${EBK}: can't mkdir ${ebk_store_dir}." 166 mkdir -p "${ebk_store_dir}" || die "BK: couldn't mkdir ${ebk_store_dir}"
174 fi 167 fi
175 168
176 pushd "${ebk_store_dir}" || die "${EBK}: can't chdir to ${ebk_store_dir}" 169 pushd "${ebk_store_dir}" || die "BK: couldn't chdir to ${ebk_store_dir}"
177 170
178 local wc_path=${reposuf} 171 local wc_path=${reposuf}
179 172
180 if [[ ! -d "${wc_path}" ]]; then 173 if [[ ! -d "${wc_path}" ]] ; then
181 local options="-r+" 174 local options="-r+"
175
182 # first check out 176 # first checkout
183 einfo "bitkeeper check out start -->" 177 einfo "bitkeeper checkout start -->"
184 einfo " repository: ${repo_uri}" 178 einfo " repository: ${repo_uri}"
179
185 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \ 180 ${ebk_fetch_cmd} ${options} "${repo_uri}" "${wc_path}" \
186 || die "${EBK}: can't fetch from ${repo_uri}." 181 || die "BK: couldn't fetch from ${repo_uri}"
187 else 182 else
188 if [[ ! -d "${wc_path}/BK" ]]; then 183 if [[ ! -d "${wc_path}/BK" ]] ; then
189 popd 184 popd
190 die "Look like ${wc_path} is not a bitkeeper path." 185 die "Looks like ${wc_path} is not a bitkeeper path"
191 fi 186 fi
192 187
193 # update working copy 188 # update working copy
194 einfo "bitkeeper update start -->" 189 einfo "bitkeeper update start -->"
195 einfo " repository: ${repo_uri}" 190 einfo " repository: ${repo_uri}"
196 191
197 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \ 192 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
198 || die "BK: can't update from ${repo_uri} to ${wc_path}." 193 || die "BK: couldn't update from ${repo_uri} to ${wc_path}"
199 fi 194 fi
200 195
201 einfo " working copy: ${wc_path}" 196 einfo " working copy: ${wc_path}"
202 cd "${wc_path}" 197 cd "${wc_path}"
203 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: can't export to ${S}." 198 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: couldn't export to ${S}"
204 199
205 echo 200 echo
206 popd 201 popd
207
208} 202}
209 203
210mysql_disable_test() { 204mysql_disable_test() {
211 local testname="${1}" ; shift 205 local testname="${1}" ; shift
212 local reason="${@}" 206 local reason="${@}"
213 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 207 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
214 echo ${testname} : ${reason} >> "${mysql_disable_file}" 208 echo ${testname} : ${reason} >> "${mysql_disable_file}"
215 ewarn "test \"${testname}\" disabled because: \"${reason}\"" 209 ewarn "test '${testname}' disabled: '${reason}'"
216} 210}
217 211
218# void mysql_init_vars() 212# void mysql_init_vars()
219# 213#
220# Initialize global variables 214# Initialize global variables
221# 2005-11-19 <vivo@gentoo.org> 215# 2005-11-19 <vivo@gentoo.org>
222 216
223mysql_init_vars() { 217mysql_init_vars() {
224 if [[ ${SLOT} == "0" ]] ; then
225 MY_SUFFIX=""
226 else
227 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
228 fi
229 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"} 218 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
230 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"} 219 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
231 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"} 220 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
232 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"} 221 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
233 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"} 222 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"}
234 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"} 223 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"}
235 224
236 if [[ -z "${DATADIR}" ]] ; then 225 if [[ -z "${MY_DATADIR}" ]] ; then
237 DATADIR="" 226 MY_DATADIR=""
238 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then 227 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
239 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null \ 228 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
240 | sed -ne '/datadir/s|^--datadir=||p' \ 229 | sed -ne '/datadir/s|^--datadir=||p' \
241 | tail -n1` 230 | tail -n1`
242 if [[ -z "${DATADIR}" ]] ; then 231 if [[ -z "${MY_DATADIR}" ]] ; then
243 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 232 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
244 | sed -e 's/.*=\s*//'` 233 | sed -e 's/.*=\s*//' \
234 | tail -n1`
245 fi 235 fi
246 fi 236 fi
247 if [[ -z "${DATADIR}" ]] ; then 237 if [[ -z "${MY_DATADIR}" ]] ; then
248 DATADIR="${MY_LOCALSTATEDIR}" 238 MY_DATADIR="${MY_LOCALSTATEDIR}"
249 einfo "Using default DATADIR" 239 einfo "Using default MY_DATADIR"
250 fi 240 fi
251 elog "MySQL DATADIR is ${DATADIR}" 241 elog "MySQL MY_DATADIR is ${MY_DATADIR}"
252 242
253 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 243 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
254 if [[ -e "${DATADIR}" ]] ; then 244 if [[ -e "${MY_DATADIR}" ]] ; then
255 elog "Previous datadir found, it's YOUR job to change" 245 elog "Previous datadir found, it's YOUR job to change"
256 elog "ownership and take care of it" 246 elog "ownership and take care of it"
257 PREVIOUS_DATADIR="yes" 247 PREVIOUS_DATADIR="yes"
258 else 248 else
259 PREVIOUS_DATADIR="no" 249 PREVIOUS_DATADIR="no"
263 fi 253 fi
264 254
265 MY_SOURCEDIR=${SERVER_URI##*/} 255 MY_SOURCEDIR=${SERVER_URI##*/}
266 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 256 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
267 257
268 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR 258 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
269 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 259 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
270 export MY_INCLUDEDIR DATADIR MY_SOURCEDIR 260 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
271} 261}
272 262
273configure_minimal() { 263configure_minimal() {
274 # These are things we exclude from a minimal build, please 264 # These are things we exclude from a minimal build, please
275 # note that the server actually does get built and installed, 265 # note that the server actually does get built and installed,
276 # but we then delete it before packaging. 266 # but we then delete it before packaging.
277 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 267 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
278 268
279 for i in ${minimal_exclude_list} ; do 269 for i in ${minimal_exclude_list} ; do
280 myconf="${myconf} --without-${i}" 270 myconf="${myconf} --without-${i}"
281 done 271 done
282 myconf="${myconf} --with-extra-charsets=none" 272 myconf="${myconf} --with-extra-charsets=none"
283 myconf="${myconf} --enable-local-infile" 273 myconf="${myconf} --enable-local-infile"
284 274
285 if useq "static" ; then 275 if use static ; then
286 myconf="${myconf} --with-client-ldflags=-all-static" 276 myconf="${myconf} --with-client-ldflags=-all-static"
287 myconf="${myconf} --disable-shared" 277 myconf="${myconf} --disable-shared --with-pic"
288 else 278 else
289 myconf="${myconf} --enable-shared --enable-static" 279 myconf="${myconf} --enable-shared --enable-static"
290 fi 280 fi
291 281
292 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 282 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
293 myconf="${myconf} --with-charset=utf8" 283 myconf="${myconf} --with-charset=utf8"
294 myconf="${myconf} --with-collation=utf8_general_ci" 284 myconf="${myconf} --with-collation=utf8_general_ci"
295 else 285 else
296 myconf="${myconf} --with-charset=latin1" 286 myconf="${myconf} --with-charset=latin1"
297 myconf="${myconf} --with-collation=latin1_swedish_ci" 287 myconf="${myconf} --with-collation=latin1_swedish_ci"
305 myconf="${myconf} --with-mysqld-user=mysql" 295 myconf="${myconf} --with-mysqld-user=mysql"
306 myconf="${myconf} --with-server" 296 myconf="${myconf} --with-server"
307 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock" 297 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
308 myconf="${myconf} --without-libwrap" 298 myconf="${myconf} --without-libwrap"
309 299
310 if useq "static" ; then 300 if use static ; then
311 myconf="${myconf} --with-mysqld-ldflags=-all-static" 301 myconf="${myconf} --with-mysqld-ldflags=-all-static"
312 myconf="${myconf} --with-client-ldflags=-all-static" 302 myconf="${myconf} --with-client-ldflags=-all-static"
313 myconf="${myconf} --disable-shared" 303 myconf="${myconf} --disable-shared --with-pic"
314 else 304 else
315 myconf="${myconf} --enable-shared --enable-static" 305 myconf="${myconf} --enable-shared --enable-static"
316 fi 306 fi
317 307
318 if useq "debug" ; then 308 if use debug ; then
319 myconf="${myconf} --with-debug=full" 309 myconf="${myconf} --with-debug=full"
320 else 310 else
321 myconf="${myconf} --without-debug" 311 myconf="${myconf} --without-debug"
322 mysql_version_is_at_least "4.1.3" \ 312 mysql_version_is_at_least "4.1.3" \
323 && useq "cluster" \ 313 && use cluster \
324 && myconf="${myconf} --without-ndb-debug" 314 && myconf="${myconf} --without-ndb-debug"
325 fi 315 fi
326 316
327 if mysql_version_is_at_least "4.1" && ! useq "latin1" ; then 317 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
328 myconf="${myconf} --with-charset=utf8" 318 myconf="${myconf} --with-charset=utf8"
329 myconf="${myconf} --with-collation=utf8_general_ci" 319 myconf="${myconf} --with-collation=utf8_general_ci"
330 else 320 else
331 myconf="${myconf} --with-charset=latin1" 321 myconf="${myconf} --with-charset=latin1"
332 myconf="${myconf} --with-collation=latin1_swedish_ci" 322 myconf="${myconf} --with-collation=latin1_swedish_ci"
333 fi 323 fi
334 324
335 if useq "embedded" ; then 325 if use embedded ; then
336 myconf="${myconf} --with-embedded-privilege-control" 326 myconf="${myconf} --with-embedded-privilege-control"
337 myconf="${myconf} --with-embedded-server" 327 myconf="${myconf} --with-embedded-server"
338 else 328 else
339 myconf="${myconf} --without-embedded-privilege-control" 329 myconf="${myconf} --without-embedded-privilege-control"
340 myconf="${myconf} --without-embedded-server" 330 myconf="${myconf} --without-embedded-server"
348 myconf="${myconf} --with-extra-tools" 338 myconf="${myconf} --with-extra-tools"
349 myconf="${myconf} --with-innodb" 339 myconf="${myconf} --with-innodb"
350 myconf="${myconf} --without-readline" 340 myconf="${myconf} --without-readline"
351 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 341 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
352 342
353 if useq "ssl" ; then
354 # --with-vio is not needed anymore, it's on by default and 343 # --with-vio is not needed anymore, it's on by default and
355 # has been removed from configure 344 # has been removed from configure
345 if use ssl ; then
356 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 346 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
347 fi
348
357 if mysql_version_is_at_least "5.0.6" ; then 349 if mysql_version_is_at_least "5.1.11" ; then
358 # myconf="${myconf} --with-yassl"
359 myconf="${myconf} --with-ssl" 350 myconf="${myconf} $(use_with ssl)"
351 else
352 myconf="${myconf} $(use_with ssl openssl)"
353 fi
354
355 if use berkdb ; then
356 # The following fix is due to a bug with bdb on SPARC's. See:
357 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
358 # It comes down to non-64-bit safety problems.
359 if use alpha || use amd64 || use hppa || use mips || use sparc ; then
360 elog "Berkeley DB support was disabled due to compatibility issues on this arch"
361 myconf="${myconf} --without-berkeley-db"
360 else 362 else
361 myconf="${myconf} --with-openssl" 363 myconf="${myconf} --with-berkeley-db=./bdb"
362 fi
363 else
364 myconf="${myconf} --without-openssl"
365 fi 364 fi
366 365 else
367 # The following fix is due to a bug with bdb on SPARC's. See:
368 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
369 # It comes down to non-64-bit safety problems.
370 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
371 elog "Berkeley DB support was disabled due to incompatible arch"
372 myconf="${myconf} --without-berkeley-db" 366 myconf="${myconf} --without-berkeley-db"
373 else
374 if useq "berkdb" ; then
375 myconf="${myconf} --with-berkeley-db=./bdb"
376 else
377 myconf="${myconf} --without-berkeley-db"
378 fi
379 fi 367 fi
380 368
381 if mysql_version_is_at_least "4.1.3" ; then 369 if mysql_version_is_at_least "4.1.3" ; then
382 myconf="${myconf} --with-geometry" 370 myconf="${myconf} --with-geometry"
383 myconf="${myconf} $(use_with cluster ndbcluster)" 371 myconf="${myconf} $(use_with cluster ndbcluster)"
384 fi 372 fi
385 373
386 if mysql_version_is_at_least "4.1.3" && useq "extraengine" ; then 374 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
387 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 375 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
388 myconf="${myconf} --with-archive-storage-engine" 376 myconf="${myconf} --with-archive-storage-engine"
389 377
390 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 378 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
391 myconf="${myconf} --with-csv-storage-engine" 379 myconf="${myconf} --with-csv-storage-engine"
402 myconf="${myconf} --with-federated-storage-engine" 390 myconf="${myconf} --with-federated-storage-engine"
403 fi 391 fi
404 fi 392 fi
405 393
406 mysql_version_is_at_least "5.0.18" \ 394 mysql_version_is_at_least "5.0.18" \
407 && useq "max-idx-128" \ 395 && use max-idx-128 \
408 && myconf="${myconf} --with-max-indexes=128" 396 && myconf="${myconf} --with-max-indexes=128"
409} 397}
410 398
411configure_51() { 399configure_51() {
412 # TODO: !!!! readd --without-readline 400 # TODO: !!!! readd --without-readline
417 myconf="${myconf} --with-geometry" 405 myconf="${myconf} --with-geometry"
418 myconf="${myconf} --with-readline" 406 myconf="${myconf} --with-readline"
419 myconf="${myconf} --with-row-based-replication" 407 myconf="${myconf} --with-row-based-replication"
420 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 408 myconf="${myconf} --with-zlib=/usr/$(get_libdir)"
421 myconf="${myconf} --without-pstack" 409 myconf="${myconf} --without-pstack"
422 useq "max-idx-128" && myconf="${myconf} --with-max-indexes=128" 410 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
423 411
424 # 5.1 introduces a new way to manage storage engines (plugins) 412 # 5.1 introduces a new way to manage storage engines (plugins)
425 # like configuration=none 413 # like configuration=none
426 local plugins="csv,myisam,myisammrg,heap" 414 local plugins="csv,myisam,myisammrg,heap"
427 if useq "extraengine" ; then 415 if use extraengine ; then
428 # like configuration=max-no-ndb, archive and example removed in 5.1.11 416 # like configuration=max-no-ndb, archive and example removed in 5.1.11
429 plugins="${plugins},archive,blackhole,example,federated,partition" 417 plugins="${plugins},archive,blackhole,example,federated,partition"
430 418
431 elog "Before using the Federated storage engine, please be sure to read" 419 elog "Before using the Federated storage engine, please be sure to read"
432 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 420 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
433 fi 421 fi
434 422
435 if useq "innodb" ; then 423 if use innodb ; then
436 plugins="${plugins},innobase" 424 plugins="${plugins},innobase"
437 fi 425 fi
438 426
439 # like configuration=max-no-ndb 427 # like configuration=max-no-ndb
440 if useq "cluster" ; then 428 if use cluster ; then
441 plugins="${plugins},ndbcluster" 429 plugins="${plugins},ndbcluster"
442 myconf="${myconf} --with-ndb-binlog" 430 myconf="${myconf} --with-ndb-binlog"
443 fi 431 fi
444 432
445 if mysql_version_is_at_least "5.2" ; then 433 if mysql_version_is_at_least "5.2" ; then
455 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 443 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
456 444
457 einfo "Reconfiguring dir '${PWD}'" 445 einfo "Reconfiguring dir '${PWD}'"
458 AT_GNUCONF_UPDATE="yes" eautoreconf 446 AT_GNUCONF_UPDATE="yes" eautoreconf
459 447
460 local myconf 448 local myconf=""
461 myconf="${myconf} --with-mysql=${S}"
462 mkdir -p ${T}/lib
463 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}" 449 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}"
464 useq "debug" && myconf="${myconf} --with-debug=full" 450 use debug && myconf="${myconf} --with-debug=full"
465 # TODO is safe/needed to use econf here ? 451 # TODO: is it safe/needed to use econf here ?
466 ./configure ${myconf} || die "problem configuring pbxt storage engine" 452 ./configure ${myconf} || die "Problem configuring PBXT storage engine"
467 # TODO is safe/needed to use emake here ? 453 # TODO: is it safe/needed to use emake here ?
468 make || die "problem making pbxt storage engine (${myconf})" 454 make || die "Problem making PBXT storage engine (${myconf})"
469 455
470 popd 456 popd
471 # TODO: modify test suite 457 # TODO: modify test suite for PBXT
472} 458}
473 459
474pbxt_src_install() { 460pbxt_src_install() {
475 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 461 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
476 make install || die "failed pbxt install" 462 make install || die "Failed to install PBXT"
477 popd 463 popd
478} 464}
479 465
480# 466#
481# EBUILD FUNCTIONS 467# EBUILD FUNCTIONS
482# 468#
483
484mysql_pkg_setup() { 469mysql_pkg_setup() {
485 enewgroup mysql 60 || die "problem adding 'mysql' group" 470 if hasq test ${FEATURES} ; then
486 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 471 if ! use minimal ; then
472 if [[ $UID -eq 0 ]]; then
473 die "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
474 fi
475 fi
476 fi
477
478 # Bug #213475 - MySQL _will_ object strenously if your machine is named
479 # localhost. Also causes weird failures.
480 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
487 481
488 # Check for USE flag problems in pkg_setup 482 # Check for USE flag problems in pkg_setup
489 if useq "static" && useq "ssl" ; then 483 if use static && use ssl ; then
490 eerror "MySQL does not support being built statically with SSL support enabled!" 484 eerror "MySQL does not support being built statically with SSL support enabled!"
491 die "MySQL does not support being built statically with SSL support enabled!" 485 die "MySQL does not support being built statically with SSL support enabled!"
492 fi 486 fi
493 487
494 if ! mysql_version_is_at_least "5.0" \ 488 if ! mysql_version_is_at_least "5.0" \
495 && useq "raid" \ 489 && use raid \
496 && useq "static" ; then 490 && use static ; then
497 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically" 491 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
498 eerror "with RAID support enabled." 492 eerror "with RAID support enabled."
499 die "USE flags 'raid' and 'static' conflict!" 493 die "USE flags 'raid' and 'static' conflict!"
500 fi 494 fi
501 495
502 if mysql_version_is_at_least "4.1.3" \ 496 if mysql_version_is_at_least "4.1.3" \
503 && ( useq "cluster" || useq "extraengine" ) \ 497 && ( use cluster || use extraengine ) \
504 && useq "minimal" ; then 498 && use minimal ; then
505 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 499 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
506 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 500 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
507 fi 501 fi
502
503 # This should come after all of the die statements
504 enewgroup mysql 60 || die "problem adding 'mysql' group"
505 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
508 506
509 mysql_check_version_range "4.0 to 5.0.99.99" \ 507 mysql_check_version_range "4.0 to 5.0.99.99" \
510 && useq "berkdb" \ 508 && use berkdb \
511 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 509 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
512} 510}
513 511
514mysql_src_unpack() { 512mysql_src_unpack() {
515 # Initialize the proper variables first 513 # Initialize the proper variables first
516 mysql_init_vars 514 mysql_init_vars
517 515
518 unpack ${A} 516 unpack ${A}
517 # Grab the patches
518 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
519 # Bitkeeper checkout support
519 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then 520 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then
520 if mysql_check_version_range "5.1 to 5.1.99" ; then 521 if mysql_check_version_range "5.1 to 5.1.99" ; then
521 bitkeeper_fetch "mysql-5.1-ndb" 522 bitkeeper_fetch "mysql-5.1-ndb"
522 elif mysql_check_version_range "5.2.0 to 5.2.99" ; then 523 elif mysql_check_version_range "5.2 to 5.2.99" ; then
523 bitkeeper_fetch "mysql-5.2-falcon" 524 bitkeeper_fetch "mysql-5.2-falcon"
524 else 525 else
525 bitkeeper_fetch 526 bitkeeper_fetch
526 fi 527 fi
527 cd "${S}" 528 cd "${S}"
528 einfo "running upstream autorun on bk sources" 529 einfo "Running upstream autorun over BK sources ..."
529 BUILD/autorun.sh 530 BUILD/autorun.sh
530 else 531 else
531 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}" 532 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
532 cd "${S}" 533 cd "${S}"
533 fi 534 fi
534 535
535 # Apply the patches for this MySQL version 536 # Apply the patches for this MySQL version
536 EPATCH_SUFFIX="patch" 537 EPATCH_SUFFIX="patch"
537 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory" 538 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
539 # Clean out old items
540 rm -f "${EPATCH_SOURCE}"/*
541 # Now link in right patches
538 mysql_mv_patches 542 mysql_mv_patches
539 epatch || die "failed to apply all patches" 543 # And apply
544 epatch
540 545
541 # Additional checks, remove bundled zlib 546 # Additional checks, remove bundled zlib
542 rm -f "${S}/zlib/"*.[ch] 547 rm -f "${S}/zlib/"*.[ch]
543 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 548 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
544 rm -f "scripts/mysqlbug" 549 rm -f "scripts/mysqlbug"
559 564
560 local rebuilddirlist d 565 local rebuilddirlist d
561 566
562 if mysql_version_is_at_least "5.1.12" ; then 567 if mysql_version_is_at_least "5.1.12" ; then
563 rebuilddirlist="." 568 rebuilddirlist="."
564 # TODO IMPO! Check this with a cmake expert 569 # TODO: check this with a cmake expert
565 useq "innodb" \ 570 use innodb \
566 && cmake \ 571 && cmake \
567 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \ 572 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
568 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \ 573 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
569 "storage/innobase" 574 "storage/innobase"
570 else 575 else
571 rebuilddirlist=". innobase" 576 rebuilddirlist=". innobase"
572 fi 577 fi
573 578
577 AT_GNUCONF_UPDATE="yes" eautoreconf 582 AT_GNUCONF_UPDATE="yes" eautoreconf
578 popd &>/dev/null 583 popd &>/dev/null
579 done 584 done
580 585
581 if mysql_check_version_range "4.1 to 5.0.99.99" \ 586 if mysql_check_version_range "4.1 to 5.0.99.99" \
582 && useq "berkdb" ; then 587 && use berkdb ; then
583 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh" 588 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
589 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
590 || die "Could not copy libtool.m4 to bdb/dist/"
584 pushd "bdb/dist" \ 591 pushd "bdb/dist" &>/dev/null
585 && sh s_all \ 592 sh s_all \
586 || die "Failed bdb reconfigure" \ 593 || die "Failed bdb reconfigure"
587 &>/dev/null
588 popd &>/dev/null 594 popd &>/dev/null
589 fi 595 fi
590} 596}
591 597
592mysql_src_compile() { 598mysql_src_compile() {
594 mysql_init_vars 600 mysql_init_vars
595 601
596 # $myconf is modified by the configure_* functions 602 # $myconf is modified by the configure_* functions
597 local myconf="" 603 local myconf=""
598 604
599 if useq "minimal" ; then 605 if use minimal ; then
600 configure_minimal 606 configure_minimal
601 else 607 else
602 configure_common 608 configure_common
603 if mysql_version_is_at_least "5.1.10" ; then 609 if mysql_version_is_at_least "5.1.10" ; then
604 configure_51 610 configure_51
618 mysql_version_is_at_least "5.0" \ 624 mysql_version_is_at_least "5.0" \
619 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 625 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
620 export CXXFLAGS 626 export CXXFLAGS
621 627
622 econf \ 628 econf \
623 --program-suffix="${MY_SUFFIX}" \
624 --libexecdir="/usr/sbin" \ 629 --libexecdir="/usr/sbin" \
625 --sysconfdir="${MY_SYSCONFDIR}" \ 630 --sysconfdir="${MY_SYSCONFDIR}" \
626 --localstatedir="${MY_LOCALSTATEDIR}" \ 631 --localstatedir="${MY_LOCALSTATEDIR}" \
627 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 632 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
628 --libdir="${MY_LIBDIR}" \ 633 --libdir="${MY_LIBDIR}" \
639 | xargs -0 -n100 sed -i \ 644 | xargs -0 -n100 sed -i \
640 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 645 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
641 646
642 emake || die "emake failed" 647 emake || die "emake failed"
643 648
644 mysql_version_is_at_least "5.1.1" && useq "pbxt" && pbxt_src_compile 649 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile
645} 650}
646 651
647mysql_src_install() { 652mysql_src_install() {
648 # Make sure the vars are correctly initialized 653 # Make sure the vars are correctly initialized
649 mysql_init_vars 654 mysql_init_vars
650 655
651 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die 656 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed"
652 657
653 mysql_version_is_at_least "5.1.12" && useq "pbxt" && pbxt_src_install 658 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install
654 659
655 insinto "${MY_INCLUDEDIR}" 660 insinto "${MY_INCLUDEDIR}"
656 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 661 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
657 662
658 # Convenience links 663 # Convenience links
659 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}" 664 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
660 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}" 665 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
661 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}" 666 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
662 667
663 # Various junk (my-*.cnf moved elsewhere) 668 # Various junk (my-*.cnf moved elsewhere)
664 rm -Rf "${D}/usr/share/info" 669 rm -Rf "${D}/usr/share/info"
665 for removeme in "mysql-log-rotate" mysql.server* \ 670 for removeme in "mysql-log-rotate" mysql.server* \
666 binary-configure* my-*.cnf mi_test_all* 671 binary-configure* my-*.cnf mi_test_all*
667 do 672 do
668 rm -f "${D}"/usr/share/mysql/${removeme} 673 rm -f "${D}"/usr/share/mysql/${removeme}
669 done 674 done
670 675
671 # TODO change at Makefile-am level
672 if [[ ${PN} == "mysql-slotted" ]] ; then
673 for moveme in "mysql_fix_privilege_tables.sql" \
674 "fill_help_tables.sql" "ndb-config-2-node.ini"
675 do
676 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
677 done
678 fi
679
680 # clean up stuff for a minimal build 676 # Clean up stuff for a minimal build
681 if useq "minimal" ; then 677 if use minimal ; then
682 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 678 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
683 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 679 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
684 rm -f "${D}/usr/sbin/mysqld" 680 rm -f "${D}/usr/sbin/mysqld"
685 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 681 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
686 fi 682 fi
687 683
688 if [[ ${PN} == "mysql-slotted" ]] ; then
689 local notcatched=$(ls "${D}/usr/share/mysql"/*)
690 if [[ -n "${notcatched}" ]] ; then
691 ewarn "QA notice"
692 ewarn "${notcatched} files in /usr/share/mysql"
693 ewarn "bug mysql-herd to manage them"
694 fi
695 rm -Rf "${D}/usr/share/mysql"
696 fi
697
698 # Configuration stuff 684 # Configuration stuff
699 if mysql_version_is_at_least "4.1" ; then 685 if mysql_version_is_at_least "4.1" ; then
700 mysql_mycnf_version="4.1" 686 mysql_mycnf_version="4.1"
701 else 687 else
702 mysql_mycnf_version="4.0" 688 mysql_mycnf_version="4.0"
703 fi 689 fi
704 insinto "${MY_SYSCONFDIR}" 690 insinto "${MY_SYSCONFDIR}"
705 doins scripts/mysqlaccess.conf 691 doins scripts/mysqlaccess.conf
706 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
707 -e "s!@DATADIR@!${DATADIR}!g" \ 692 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
708 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 693 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
709 > "${TMPDIR}/my.cnf.ok" 694 > "${TMPDIR}/my.cnf.ok"
710 if mysql_version_is_at_least "4.1" && useq "latin1" ; then 695 if mysql_version_is_at_least "4.1" && use latin1 ; then
711 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 696 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
712 fi 697 fi
713 newins "${TMPDIR}/my.cnf.ok" my.cnf 698 newins "${TMPDIR}/my.cnf.ok" my.cnf
714 699
715 # Minimal builds don't have the MySQL server 700 # Minimal builds don't have the MySQL server
716 if ! useq "minimal" ; then 701 if ! use minimal ; then
717 # Empty directories ... 702 # Empty directories ...
718 diropts "-m0750" 703 diropts "-m0750"
719 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 704 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
720 dodir "${DATADIR}" 705 dodir "${MY_DATADIR}"
721 keepdir "${DATADIR}" 706 keepdir "${MY_DATADIR}"
722 chown -R mysql:mysql "${D}/${DATADIR}" 707 chown -R mysql:mysql "${D}/${MY_DATADIR}"
723 fi 708 fi
724 709
725 diropts "-m0755" 710 diropts "-m0755"
726 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do 711 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do
727 dodir "${folder}" 712 dodir "${folder}"
730 done 715 done
731 fi 716 fi
732 717
733 # Docs 718 # Docs
734 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 719 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
720 doinfo "${S}"/Docs/mysql.info
735 721
736 # Minimal builds don't have the MySQL server 722 # Minimal builds don't have the MySQL server
737 if ! useq "minimal" ; then 723 if ! use minimal ; then
724 docinto "support-files"
725 for script in \
726 "${S}"/support-files/my-*.cnf \
727 "${S}"/support-files/magic \
728 "${S}"/support-files/ndb-config-2-node.ini
729 do
730 dodoc "${script}"
731 done
732
733 docinto "scripts"
734 for script in "${S}"/scripts/mysql* ; do
735 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
736 done
737
738 fi
739
740 mysql_lib_symlinks "${D}"
741}
742
743mysql_pkg_preinst() {
744 enewgroup mysql 60 || die "problem adding 'mysql' group"
745 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
746}
747
748mysql_pkg_postinst() {
749 # Make sure the vars are correctly initialized
750 mysql_init_vars
751
752 # Check FEATURES="collision-protect" before removing this
753 [[ -d "${ROOT}/var/log/mysql" ]] || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
754
755 # Secure the logfiles
756 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
757 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
758 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
759
760 # Minimal builds don't have the MySQL server
761 if ! use minimal ; then
738 docinto "support-files" 762 docinto "support-files"
739 for script in \ 763 for script in \
740 support-files/my-*.cnf \ 764 support-files/my-*.cnf \
741 support-files/magic \ 765 support-files/magic \
742 support-files/ndb-config-2-node.ini 766 support-files/ndb-config-2-node.ini
746 770
747 docinto "scripts" 771 docinto "scripts"
748 for script in scripts/mysql* ; do 772 for script in scripts/mysql* ; do
749 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 773 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
750 done 774 done
751 fi
752 775
753 if [[ ${PN} == "mysql-slotted" ]] ; then 776 einfo
754 # MOVED HERE DUE TO BUG #121445 777 elog "You might want to run:"
755 # create a list of files, to be used 778 elog "\"emerge --config =${CATEGORY}/${PF}\""
756 # by external utilities 779 elog "if this is a new install."
757 mkdir -p "${D}/var/lib/eselect/mysql/" 780 einfo
758 local filelist="${D}/var/lib/eselect/mysql/mysql${MY_SUFFIX}.filelist"
759 pushd "${D}/" &>/dev/null
760 find usr/bin/ usr/sbin/ \
761 -type f -name "*${MY_SUFFIX}*" \
762 -and -not -name "mysql_config${MY_SUFFIX}" \
763 > "${filelist}"
764 find usr/share/man \
765 -type f -name "*${MY_SUFFIX}*" \
766 | sed -e 's/$/.gz/' \
767 >> "${filelist}"
768 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
769 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
770 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
771 popd &>/dev/null
772 fi 781 fi
773 782
774 mysql_lib_symlinks "${D}" 783 if mysql_version_is_at_least "5.1.12" && use pbxt ; then
775} 784 # TODO: explain it better
776
777mysql_pkg_preinst() {
778 enewgroup mysql 60 || die "problem adding 'mysql' group"
779 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
780}
781
782mysql_pkg_postinst() {
783 # Make sure the vars are correctly initialized
784 mysql_init_vars
785
786 # Check FEATURES="collision-protect" before removing this
787 [[ -d "${ROOT}/var/log/mysql" ]] \
788 || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
789
790 # Secure the logfiles
791 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
792 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
793 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
794
795 # Minimal builds don't have the MySQL server
796 if ! useq "minimal" ; then
797 docinto "support-files"
798 for script in \
799 support-files/my-*.cnf \
800 support-files/magic \
801 support-files/ndb-config-2-node.ini
802 do
803 dodoc "${script}"
804 done
805
806 docinto "scripts"
807 for script in scripts/mysql* ; do
808 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
809 done
810 fi
811
812 einfo "you may want to read slotting upgrade documents in the overlay"
813 if useq "pbxt" && mysql_version_is_at_least "5.1" ; then
814 # TODO tell it better ;-)
815 einfo "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 785 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
816 einfo "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 786 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
817 einfo "if, after that you cannot start the mysql server" 787 elog "if, after that, you cannot start the MySQL server,"
818 einfo "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 788 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
819 einfo "use the mysql upgrade script to restore the table" 789 elog "use the MySQL upgrade script to restore the table"
820 einfo " or " 790 elog "or execute the following SQL command:"
821 einfo "CREATE TABLE IF NOT EXISTS plugin (" 791 elog " CREATE TABLE IF NOT EXISTS plugin ("
822 einfo " name char(64) binary DEFAULT '' NOT NULL," 792 elog " name char(64) binary DEFAULT '' NOT NULL,"
823 einfo " dl char(128) DEFAULT '' NOT NULL," 793 elog " dl char(128) DEFAULT '' NOT NULL,"
824 einfo " PRIMARY KEY (name)" 794 elog " PRIMARY KEY (name)"
825 einfo ") CHARACTER SET utf8 COLLATE utf8_bin;" 795 elog " ) CHARACTER SET utf8 COLLATE utf8_bin;"
826 fi 796 fi
797
827 mysql_check_version_range "4.0 to 5.0.99.99" \ 798 mysql_check_version_range "4.0 to 5.0.99.99" \
828 && useq "berkdb" \ 799 && use berkdb \
829 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 800 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
830} 801}
831 802
832mysql_pkg_config() { 803mysql_pkg_config() {
833 # Make sure the vars are correctly initialized 804 # Make sure the vars are correctly initialized
834 mysql_init_vars 805 mysql_init_vars
835 806
836 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 807 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
837 808
838 if built_with_use ${CATEGORY}/${PN} minimal ; then 809 if built_with_use ${CATEGORY}/${PN} minimal ; then
839 die "Minimal builds do NOT include the MySQL server" 810 die "Minimal builds do NOT include the MySQL server"
840 fi 811 fi
841 812
842 local pwd1="a" 813 local pwd1="a"
843 local pwd2="b" 814 local pwd2="b"
844 local maxtry=5 815 local maxtry=5
845 816
846 if [[ -d "${ROOT}/${DATADIR}/mysql" ]] ; then 817 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
847 ewarn "You have already a MySQL database in place." 818 ewarn "You have already a MySQL database in place."
848 ewarn "(${ROOT}/${DATADIR}/*)" 819 ewarn "(${ROOT}/${MY_DATADIR}/*)"
849 ewarn "Please rename or delete it if you wish to replace it." 820 ewarn "Please rename or delete it if you wish to replace it."
850 die "MySQL database already exists!" 821 die "MySQL database already exists!"
851 fi 822 fi
852 823
853 einfo "Creating the mysql database and setting proper" 824 einfo "Creating the mysql database and setting proper"
872 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \ 843 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
873 || touch "${TMPDIR}/fill_help_tables.sql" 844 || touch "${TMPDIR}/fill_help_tables.sql"
874 help_tables="${TMPDIR}/fill_help_tables.sql" 845 help_tables="${TMPDIR}/fill_help_tables.sql"
875 846
876 pushd "${TMPDIR}" &>/dev/null 847 pushd "${TMPDIR}" &>/dev/null
877 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR" 848 "${ROOT}/usr/bin/mysql_install_db" >"${TMPDIR}"/mysql_install_db.log 2>&1
849 if [ $? -ne 0 ]; then
850 grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
851 die "Failed to run mysql_install_db. Please review /var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
852 fi
878 popd &>/dev/null 853 popd &>/dev/null
879 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \ 854 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
880 || die "MySQL databases not installed" 855 || die "MySQL databases not installed"
881 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null 856 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
882 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null 857 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
883 858
884 if mysql_version_is_at_least "4.1.3" ; then 859 if mysql_version_is_at_least "4.1.3" ; then
885 options="--skip-ndbcluster" 860 options="--skip-ndbcluster"
886 861
887 # Filling timezones, see 862 # Filling timezones, see
898 local mysqld="${ROOT}/usr/sbin/mysqld \ 873 local mysqld="${ROOT}/usr/sbin/mysqld \
899 ${options} \ 874 ${options} \
900 --user=mysql \ 875 --user=mysql \
901 --skip-grant-tables \ 876 --skip-grant-tables \
902 --basedir=${ROOT}/usr \ 877 --basedir=${ROOT}/usr \
903 --datadir=${ROOT}/${DATADIR} \ 878 --datadir=${ROOT}/${MY_DATADIR} \
904 --skip-innodb \ 879 --skip-innodb \
905 --skip-bdb \ 880 --skip-bdb \
906 --skip-networking \ 881 --skip-networking \
907 --max_allowed_packet=8M \ 882 --max_allowed_packet=8M \
908 --net_buffer_length=16K \ 883 --net_buffer_length=16K \
938 wait %1 913 wait %1
939 einfo "Done" 914 einfo "Done"
940} 915}
941 916
942mysql_pkg_postrm() { 917mysql_pkg_postrm() {
943 if [[ ${PN} == "mysql-slotted" ]] ; then
944 mysql_lib_symlinks 918 : # mysql_lib_symlinks "${D}"
945 mysql_clients_link_to_best_version
946 fi
947} 919}

Legend:
Removed from v.1.59  
changed lines
  Added in v.1.94

  ViewVC Help
Powered by ViewVC 1.1.20